unit UVerwaltung;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, ExtCtrls, Buttons,
  UEinlesen, UAusgeben,
  USortElement,UBasisobjekte,
  ULinListNode,ULinList;


type TFVerwaltung = class(TForm)
    BtNachHinten: TButton;
    BtAnfangListe: TButton;
    BtInsert: TButton;
    BtGetElement: TButton;
    BtAdd: TButton;
    EdIndex: TEdit;
    EdCount: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    BtDeleteAll: TButton;
    Label3: TLabel;
    Label6: TLabel;
    BtDelete: TButton;
    LbAusgabe: TListBox;
    EdAktuell: TEdit;

    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

    procedure BtAnfangListeClick(Sender: TObject);
    procedure BtNachHintenClick(Sender: TObject);
    procedure BtInsertClick(Sender: TObject);
    procedure BtGetElementClick(Sender: TObject);
    procedure BtAddClick(Sender: TObject);
    procedure BtDeleteAllClick(Sender: TObject);
    procedure BtDeleteClick(Sender: TObject);

    private
        hListe: TLinList;
        procedure Anfangswerte;
        procedure Anzeigen;
end;

var FVerwaltung  : TFVerwaltung;
    inhalt : TSortElement;

implementation


{$R *.DFM}

(*************************** private Methoden ****************************)

procedure TFVerwaltung.Anfangswerte;
begin
  inhalt := TInteger.create(1);
  hliste.add(inhalt);
 end;

procedure TFVerwaltung.Anzeigen;
var merk: Integer;
    aktuell:TSortElement;
begin
    merk := hListe.GetIndex; 
    EdIndex.text := IntToStr(hListe.GetIndex);
    EdCount.text := IntToStr(hListe.GetCount);
    LbAusgabe.items.Clear;
    EdAktuell.Text := '';
    if not hliste.isempty then begin
       EdAktuell.Text := TSortElement(hListe.GetElement).Gettext;
       if hListe.Getindex = 1 then
          LbAusgabe.items.Add ('pre->dummy')
       else
          LbAusgabe.items.Add ('     dummy');
       hListe.first;
       while not hListe.islast do begin
          aktuell := TSortElement(hListe.GetElement);
          if merk = hListe.GetIndex+1 then
             LbAusgabe.items.Add ('pre-->  '+aktuell.getText)
          else if merk = hliste.GetIndex then
             LbAusgabe.items.Add ('act===> '+aktuell.getText)
          else
             LbAusgabe.items.Add ('        '+aktuell.getText);
          hListe.next;
       end; (* of while *)
       aktuell := TSortElement(hListe.GetElement);
         if merk <> hListe.GetIndex then
            LbAusgabe.items.Add ('        '+aktuell.getText)
         else
            LbAusgabe.items.Add ('act===> '+aktuell.getText);
       LbAusgabe.items.Add ('      nil');
       hliste.first;
       while merk <> hListe.GetIndex do begin
          hliste.next
       end
   end
end; {procedure}

(***********************  Ereignismethoden  ***********************************)

procedure TFVerwaltung.FormCreate(Sender: TObject);
begin
  hListe := TLinList.Create;
  Anfangswerte;
  Anzeigen;
end;

procedure TFVerwaltung.BtAnfangListeClick(Sender: TObject);
begin
  hListe.first;
  anzeigen;
end;

procedure TFVerwaltung.BtNachHintenClick(Sender: TObject);
begin
    hListe.next;
    anzeigen;
end;

procedure TFVerwaltung.BtInsertClick(Sender: TObject);
var
  S,N:string;
begin
    if FormEinlesen.ShowModal=mrOK then begin
       try
        S:=FormEinlesen.edit1.text;
        N:=FormEinlesen.edit2.text;
        case FormEinlesen.Radiogroup1.itemindex of
        0: hListe.insert(TInteger.create(StrToInt(S)));
        1: hListe.insert(TBruchzahl.Create(StrToInt(S),StrToInt(N)));
        2: hListe.insert(TReal.create(StrToFloat(S)));
        3: hListe.insert(TString.create(S));
        end;
        anzeigen;
      except
          on EConvertError do
            case FormEinlesen.Radiogroup1.Itemindex of
              0:showmessage('Keine ganze Zahl');
              1:showmessage('Keine Dezimalzahl');
            end;
        end;
    end;
end;

procedure TFVerwaltung.BtAddClick(Sender: TObject);
var
  S,N:string;
begin
    if FormEinlesen.ShowModal=mrOK then begin
       try
        S:=FormEinlesen.edit1.text;
        N:=FormEinlesen.edit2.text;
        case FormEinlesen.Radiogroup1.itemindex of
        0: hListe.add(TInteger.create(StrToInt(S)));
        1: hListe.add(TBruchzahl.Create(StrToInt(S),StrToInt(N)));
        2: hListe.add(TReal.create(StrToFloat(S)));
        3: hListe.add(TString.create(S));
        end;
        anzeigen;
      except
          on EConvertError do
            case FormEinlesen.Radiogroup1.Itemindex of
              0:showmessage('Keine ganze Zahl');
              1:showmessage('Keine Dezimalzahl');
            end;
        end;
    end;
end;

procedure TFVerwaltung.BtGetElementClick(Sender: TObject);
var
  P:TSortElement;
  Fehler:boolean;
begin
   Fehler := False;
   P:=TSortElement(hListe.GetElement);
   with FormAusgabe do begin
     EdInteger.Text:='';
     EdBruch.Text:='';
     EdReal.text:='';
     EdString.Text:='';
     if P is TInteger then EdInteger.Text:=P.GetText
     else if P is TReal then EdReal.Text:=P.GetText
          else if P is TString then EdString.Text:=P.GetText
               else if P is TBruchzahl then EdBruch.Text := P.GetText
               else Fehler:=true;
     if not Fehler then
         ShowModal
    end (* of with *)
end;

procedure TFVerwaltung.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  BtDeleteAllClick(sender);
  hListe.Destroy;
end;

procedure TFVerwaltung.BtDeleteAllClick(Sender: TObject);
begin
   hListe.first;
   while not hliste.isempty do begin
      hliste.GetElement.Destroy;
      hListe.Delete;
   end;
   anzeigen
end;

procedure TFVerwaltung.BtDeleteClick(Sender: TObject);
begin
   hListe.Delete;
   anzeigen
end;

end.
