unit UHanoi1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls,UStapel_LinListNode,UScheibe, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    BtUmstapeln: TButton;
    EdAnzahl: TEdit;
    BtNeu: TButton;
    ImTurmA: TImage;
    ImTurmB: TImage;
    ImTurmC: TImage;
    ImHand: TImage;
    ChBPAnzeige: TCheckBox;
    procedure BtNeuClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BtUmstapelnClick(Sender: TObject);
    procedure zeige_alle_stapel;
    procedure turmtrans (n:Integer; VAR a,b,c :TStapel);
    procedure scheibentrans(var von,nach :TStapel);
   private
    stapel_a,stapel_b,stapel_c : TStapel;
    function xlinks (ScheibenNr:Integer; Turm:Timage):Integer;
    function xrechts(ScheibenNr:Integer; Turm:Timage):Integer;
    function shoehe(ScheibenNr:Integer; Turm:Timage):Integer;
    procedure zeige(st :TStapel; ImTurm :TImage);
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

(**************** hilfsprocs ***************)

procedure leere (var st :TStapel);
begin
   while not st.isempty do begin
      st.top.free;
      st.pop
   end
end;

function TForm1.xlinks(ScheibenNr:Integer; Turm:Timage):Integer;
var elementarbreite,xl : real;
begin
   elementarbreite := (Turm.width*0.9) / StrToFloat( EdAnzahl.text);
   scheibennr := StrToInt( EdAnzahl.text) - scheibennr;
   xl := (Turm.width*0.1 + elementarbreite * ScheibenNr)/2;
   result := round(xl)
end;

function TForm1.xrechts(ScheibenNr:Integer; Turm:Timage):Integer;
var elementarbreite,xr : real;
begin
   elementarbreite := (Turm.width*0.9) / StrToFloat( EdAnzahl.text);
   scheibennr := StrToInt( EdAnzahl.text) - scheibennr;
   xr := (Turm.width*0.1 + elementarbreite * ScheibenNr)/2;
   xr := turm.width - xr;
   result := round(xr)
end;

function TForm1.shoehe(ScheibenNr:Integer; Turm:Timage):Integer;
begin
   result := round(turm.height*0.9 / StrToFloat( EdAnzahl.text))
end;

procedure TForm1.zeige(st :TStapel; ImTurm :TImage);
var hilf   :TStapel;
    zahl,ypos  : Integer;
begin
   hilf := TStapel.create;
   ypos := ImTurm.height;
     while not st.isempty do begin
        hilf.push(st.top);
        st.pop
     end;

   with imTurm.canvas do begin
     brush.color := clyellow;
     rectangle(0,0,width,height);
     brush.color := clblue;
     while not hilf.isempty do begin
        zahl := TScheibe(hilf.top).get;
        rectangle(xlinks(zahl,ImTurm),ypos,
                 xrechts(zahl,ImTurm),ypos-shoehe(zahl,ImTurm));
        ypos := ypos - shoehe(zahl,ImTurm);
        st.push(hilf.top);
        hilf.pop
     end;
   end;  
   hilf.free;
end;

procedure TForm1.zeige_alle_stapel;
begin
  zeige(stapel_a, ImTurmA);
  zeige(stapel_b, ImTurmB);
  zeige(stapel_c, ImTurmC);
end;

procedure TForm1.turmtrans(n:Integer;var a,b,c :TStapel);
begin
   if ChBPAnzeige.checked then
      showmessagepos('Turmtrans '+IntToStr(n),
                         Imhand.left+Imhand.width+left+30,
                         ImHand.top+top);
   if n > 1 then turmtrans(n-1,a,c,b);
   scheibentrans(a,c);
   if n > 1 then turmtrans(n-1,b,a,c);
end;

procedure TForm1.scheibentrans(var von,nach :TStapel);
var scheibe:Tscheibe;
    zahl: Integer;
begin
   showmessagepos('Scheibe '+IntToStr(zahl)+' weg',
                   Imhand.left+Imhand.width+left+30,
                   ImHand.top+top);
   scheibe := Tscheibe.create;
   scheibe := TScheibe(von.top); von.pop;
   zahl := scheibe.get;
   zeige_alle_stapel;
   ImHand.canvas.brush.color := clblue;
   ImHand.canvas.rectangle(xlinks(zahl,ImHand),ImHand.height,
                 xrechts(zahl,Imhand),ImHand.height-shoehe(zahl,ImTurmA));
   showmessagepos('Scheibe '+IntToStr(zahl)+' hin',
                      Imhand.left+Imhand.width+left+30,
                      ImHand.top+top);
   nach.push(scheibe);
   zeige_alle_stapel;
   ImHand.canvas.brush.color := clyellow;
   ImHand.canvas.rectangle(0,0,Imhand.width,ImHand.height);
end;

procedure TForm1.BtNeuClick(Sender: TObject);
var i,anz : Integer;
    neu   :TScheibe;
begin
  anz := StrToInt(EdAnzahl.text);
  leere(stapel_a);
  leere(stapel_b);
  leere(stapel_c);
  for i := 1 to anz do begin
     neu := TScheibe.create;
     neu.put(anz-i+1);
     stapel_a.push(neu);
  end;
  zeige_alle_stapel;
  BtUmstapeln.enabled := true
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   stapel_a := TStapel.create;
   stapel_b := TStapel.create;
   stapel_c := TStapel.create;
   zeige_alle_stapel ;
   ImHand.canvas.brush.color := clyellow;
   ImHand.canvas.rectangle(0,0,Imhand.width,ImHand.height);
   BtUmstapeln.enabled := false
end;

procedure TForm1.BtUmstapelnClick(Sender: TObject);
begin
   turmtrans(StrToInt(EdAnzahl.text),stapel_a,stapel_b,stapel_c);
   BtUmstapeln.enabled := false
end;

end.
