unit UdvListNode;
interface
uses sysutils,dialogs;
type
  TdvListNode = class(TObject)
              private
                ValueP{ointer}: TObject;
                PredP{ointer},SuccP{ointer} : TdvListNode;

{                               ListNode:
                     +----------+--------+
        Object <-----+- ValueP  | SuccP -+-----> ListNode
                     +----------+--------+
 }
              public
                constructor Create       (V:TObject); virtual;
                function    ReadValue      :TObject;
                procedure   WriteValue   (V:TObject);

                function    ReadSucc       :TdvListNode;
                procedure   WriteSucc (Succ:TdvListNode);
                function    ReadPred       :TdvListNode;
                procedure   WritePred (Pred:TdvListNode);
                destructor  Destroy; override;
              end;

  Implementation

  constructor TdvListNode.create(V:TObject);
  begin
    inherited create;
    ValueP:=V;      (*    +----------+---+    *)
    Succp:=nil;     (*    | ValueP   | * |    *)
    Predp:=nil;     (*    +----------+---+    *)
  end;

  function TdvListNode.ReadValue:TObject;
  begin
   Result:=ValueP
  end;

  procedure TdvListNode.WriteValue(V:TObject);
  begin
    ValueP:=V
  end;

  function TdvListNode.ReadSucc:TdvListNode;
  begin
    REsult:=SuccP
  end;

  procedure TdvListNode.WriteSucc(Succ:TdvListNode);
  begin
     SuccP:=Succ
  end;

  function TdvListNode.ReadPred:TdvListNode;
  begin
    REsult:=PredP
  end;

  procedure TdvListNode.WritePred(Pred:TdvListNode);
  begin
     PredP:=Pred
  end;

  destructor TdvListNode.Destroy;
  begin
    inherited destroy;
    (* nur der Knoten, d.h. die Verweise werden gelscht.
       Das Objekt auf das ValueP zeigt, wird nicht gelscht !!!
       Dafr ist das Objekt zustndig, das den Inhalt
       auch erzeugt hat !! *)
  end;

end.

